/* **********************************************************
 * Copyright (C) 1999-2000, VMware, Inc.
 * All Rights Reserved.
 * $Id: Control.xs,v 1.23.2.1 2000/12/01 11:52:48 brettv Exp $*
 * **********************************************************/

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "vmcontrol.h"

static int
not_here(char *s)
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant_VM_E_NO(char *name, int len, int arg)
{
    switch (name[7 + 0]) {
    case 'A':
	if (strEQ(name + 7, "ACCESS")) {	/* VM_E_NO removed */
#ifdef VM_E_NOACCESS
	    return VM_E_NOACCESS;
#else
	    goto not_there;
#endif
	}
    case 'E':
	if (strEQ(name + 7, "EXECVMAUTHD")) {	/* VM_E_NO removed */
#ifdef VM_E_NOEXECVMAUTHD
	    return VM_E_NOEXECVMAUTHD;
#else
	    goto not_there;
#endif
	}
    case 'M':
	if (strEQ(name + 7, "MEM")) {	/* VM_E_NO removed */
#ifdef VM_E_NOMEM
	    return VM_E_NOMEM;
#else
	    goto not_there;
#endif
	}
    case 'P':
	if (strEQ(name + 7, "PROPERTY")) {	/* VM_E_NO removed */
#ifdef VM_E_NOPROPERTY
	    return VM_E_NOPROPERTY;
#else
	    goto not_there;
#endif
	}
    case 'S':
	if (strEQ(name + 7, "SUCHVM")) {	/* VM_E_NO removed */
#ifdef VM_E_NOSUCHVM
	    return VM_E_NOSUCHVM;
#else
	    goto not_there;
#endif
	}
    case 'T':
	if (strEQ(name + 7, "TCONNECTED")) {	/* VM_E_NO removed */
#ifdef VM_E_NOTCONNECTED
	    return VM_E_NOTCONNECTED;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_VM_E_NE(char *name, int len, int arg)
{
    switch (name[7 + 0]) {
    case 'E':
	if (strEQ(name + 7, "EDINPUT")) {	/* VM_E_NE removed */
#ifdef VM_E_NEEDINPUT
	    return VM_E_NEEDINPUT;
#else
	    goto not_there;
#endif
	}
    case 'T':
	if (strEQ(name + 7, "TFAIL")) {	/* VM_E_NE removed */
#ifdef VM_E_NETFAIL
	    return VM_E_NETFAIL;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_VM_E_N(char *name, int len, int arg)
{
    switch (name[6 + 0]) {
    case 'E':
	return constant_VM_E_NE(name, len, arg);
    case 'O':
	return constant_VM_E_NO(name, len, arg);
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant_VM_E_B(char *name, int len, int arg)
{
    if (6 + 2 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[6 + 2]) {
    case 'R':
	if (strEQ(name + 6, "ADRESPONSE")) {	/* VM_E_B removed */
#ifdef VM_E_BADRESPONSE
	    return VM_E_BADRESPONSE;
#else
	    goto not_there;
#endif
	}
    case 'S':
	if (strEQ(name + 6, "ADSTATE")) {	/* VM_E_B removed */
#ifdef VM_E_BADSTATE
	    return VM_E_BADSTATE;
#else
	    goto not_there;
#endif
	}
    case 'V':
	if (strEQ(name + 6, "ADVERSION")) {	/* VM_E_B removed */
#ifdef VM_E_BADVERSION
	    return VM_E_BADVERSION;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

static double
constant(char *name, int len, int arg)
{
    errno = 0;
    if (0 + 5 >= len ) {
	errno = EINVAL;
	return 0;
    }
    switch (name[0 + 5]) {
    case 'A':
	if (strEQ(name + 0, "VM_E_ALREADYCONNECTED")) {	/*  removed */
#ifdef VM_E_ALREADYCONNECTED
	    return VM_E_ALREADYCONNECTED;
#else
	    goto not_there;
#endif
	}
    case 'B':
	if (!strnEQ(name + 0,"VM_E_", 5))
	    break;
	return constant_VM_E_B(name, len, arg);
    case 'D':
	if (strEQ(name + 0, "VM_E_DISCONNECT")) {	/*  removed */
#ifdef VM_E_DISCONNECT
	    return VM_E_DISCONNECT;
#else
	    goto not_there;
#endif
	}
    case 'G':
	if (strEQ(name + 0, "VM_E_GARBAGE")) {	/*  removed */
#ifdef VM_E_GARBAGE
	    return VM_E_GARBAGE;
#else
	    goto not_there;
#endif
	}
    case 'I':
	if (strEQ(name + 0, "VM_E_INVALIDARGS")) {	/*  removed */
#ifdef VM_E_INVALIDARGS
	    return VM_E_INVALIDARGS;
#else
	    goto not_there;
#endif
	}
    case 'N':
	if (!strnEQ(name + 0,"VM_E_", 5))
	    break;
	return constant_VM_E_N(name, len, arg);
    case 'S':
	if (strEQ(name + 0, "VM_E_SUCCESS")) {	/*  removed */
#ifdef VM_E_SUCCESS
	    return VM_E_SUCCESS;
#else
	    goto not_there;
#endif
	}
    case 'T':
	if (strEQ(name + 0, "VM_E_TIMEOUT")) {	/*  removed */
#ifdef VM_E_TIMEOUT
	    return VM_E_TIMEOUT;
#else
	    goto not_there;
#endif
	}
    case 'U':
	if (strEQ(name + 0, "VM_E_UNSPECIFIED")) {	/*  removed */
#ifdef VM_E_UNSPECIFIED
	    return VM_E_UNSPECIFIED;
#else
	    goto not_there;
#endif
	}
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


MODULE = VMware::Control		PACKAGE = VMware::Control		PREFIX = VMControl_
PROTOTYPES: ENABLE

int
VMControl_Init()

const char *
VMControl_Version()

const char *
VMControl_GetErrorMessage(err)
        int     err

double
constant(sv,arg)
    PREINIT:
	STRLEN		len;
    INPUT:
	SV *		sv
	char *		s = SvPV(sv, len);
	int		arg
    CODE:
	RETVAL = constant(s,len,arg);
    OUTPUT:
	RETVAL


MODULE = VMware::Control		PACKAGE = VMware::Control::Server		PREFIX = VMControl_Server
PROTOTYPES: ENABLE

int
VMControl_ServerInit()

void
VMControl_ServerDESTROY(s)
	VMControlServer *	s
        CODE:
        VMControl_ServerDestroy(s);

void
VMControl_ServerDisconnect(s)
       VMControlServer *      s

int
VMControl_ServerConnect(s)
        VMControlServer *      s

int
VMControl_ServerIsConnected(s)
        VMControlServer *      s

char **
VMControl_ServerEnumerate(s)
	VMControlServer *	s
        PREINIT:
        char **x, **x_sav;
        PPCODE:
        x_sav = x = VMControl_ServerEnumerate(s);
        if (x) {
          while(*x) {
            XPUSHs(sv_2mortal(newSVpv(*x, 0)));
            free(*x);
            *x++;
          }
          free (x_sav);
        }

char *
VMControl_ServerExec(s, xmlargs)
	VMControlServer *	s
	const char *	xmlargs
        CLEANUP:
        if (RETVAL) free(RETVAL);

int
VMControl_ServerGetLastError(s)
        VMControlServer *       s
        PREINIT:
        int retval;
        char * string;
        PPCODE:
        retval = VMControl_ServerGetLastError(s, &string);
        XPUSHs(sv_2mortal(newSViv((IV) retval)));
        XPUSHs(sv_2mortal(newSVpv(string, 0)));
        if (string) free(string);

VMControlServer *
VMControl_ServerNew(hostname, port, username, password)
	const char *	hostname
	int	port
	const char *	username
	const char *	password

int
VMControl_ServerRegister(s, configpath)
        VMControlServer *      s
        const char *    configpath

MODULE = VMware::Control		PACKAGE = VMware::Control::VM		PREFIX = VMControl_VM
PROTOTYPES: ENABLE

int
VMControl_VMInit()

void
VMControl_VMDESTROY(vm)
	VMControlVM *	vm
        CODE:
        VMControl_VMDestroy(vm);

void
VMControl_VMDisconnect(vm)
        VMControlVM *    vm

int
VMControl_VMConnect(vm)
        VMControlVM *      vm

int
VMControl_VMIsConnected(vm)
        VMControlVM *      vm

int
VMControl_VMAnswerQuestion(vm, sequence, choicenum)
        VMControlVM *   vm
        int     sequence
        int     choicenum

int
VMControl_VMExit(vm)
	VMControlVM *	vm

char *
VMControl_VMGetAsString(vm, var)
	VMControlVM *	vm
	const char *	var
        CLEANUP:
        if (RETVAL) free(RETVAL);

int
VMControl_VMGetLastError(vm)
        VMControlVM *   vm
        PREINIT:
        int retval;
        char * string;
        PPCODE:
        retval = VMControl_VMGetLastError(vm, &string);
        XPUSHs(sv_2mortal(newSViv((IV) retval)));
        XPUSHs(sv_2mortal(newSVpv(string, 0)));
        if(string) free(string);

void
VMControl_VMSetError(vm, err, str)
	VMControlVM *	vm
        int             err
	const char *	str


char **
VMControl_VMInfo(s)
	VMControlVM *	s
        PREINIT:
        char **x, **x_sav;
        PPCODE:
        x_sav = x = VMControl_VMInfo(s);
        if (x) {
          while(*x) {
                XPUSHs(sv_2mortal(newSVpv(*x, 0)));
                *x++;
                if(*x) {
                        XPUSHs(sv_2mortal(newSVpv(*x, 0)));
                } else {
                        XPUSHs(&PL_sv_undef);
                }
                free(*x);
                *x++;
          }
          free(x_sav);
        }

VMControlVM *
VMControl_VMNew(s, config)
	VMControlServer *	s
	const char *	config

int
VMControl_VMRequestReset(vm, force)
	VMControlVM *	vm
	int force

int
VMControl_VMReset(vm, force)
	VMControlVM *	vm
	int force

int
VMControl_VMStart(vm)
	VMControlVM *	vm

int
VMControl_VMRequestStop(vm, force)
	VMControlVM *	vm
	int force

int
VMControl_VMStop(vm, force)
	VMControlVM *	vm
	int force

int
VMControl_VMSuspendToDisk(vm)
	VMControlVM *	vm

char **
VMControl_VMWho(vm)
	VMControlVM *	vm
        PREINIT:
        char **x, **x_sav;
        PPCODE:
        x_sav = x = VMControl_VMWho(vm);
        if (x) {
          while(*x) {
            XPUSHs(sv_2mortal(newSVpv(*x, 0)));
            free(*x);
            *x++;
          }
          free (x_sav);
        }


