use ExtUtils::MakeMaker;
# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.

# To make: type "perl Makefile.PL; make" in this directory.
# To check if things worked correctly, try running "make test"

WriteMakefile(
    'NAME'		=> 'VMware::Control',
    'VERSION_FROM'	=> 'Control.pm', # finds $VERSION
    'PREREQ_PM'		=> {}, # e.g., Module::Name => 1.1
    'LIBS'		=> [''], # e.g., '-lm'
    'DEFINE'		=> '', # e.g., '-DHAVE_SOMETHING'
    'INC'		=> '', # e.g., '-I/usr/include/other'

#Perl 5.005_03 (RedHat 6.1 and 6.2) automatically uses these
#    'CCFLAGS'		=> '-Dbool=char -DHAS_BOOL -I/usr/local/include',
#    'OPTIMIZE'		=> '-O2',

#Perl 5.6.0 requires these w/ gcc 2.7.2.3 or we get compiler errors 
#    'CCFLAGS'		=> '-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64',
#    'OPTIMIZE'		=> '-O3 -fomit-frame-pointer -fno-rtti -pipe -s -ffast-math -fexpensive-optimizations',

    'MYEXTLIB'          => 'vmcontrol.o',
    'PM'                => {'Control.pm' => '$(INST_LIBDIR)/Control.pm',
                            'Server.pm' => '$(INST_LIBDIR)/Control/Server.pm',
                            'VM.pm'     => '$(INST_LIBDIR)/Control/VM.pm',},
);

sub MY::postamble {
'
ifndef VERBOSE
.SILENT:
endif

ifdef WRAP_MALLOC
LDDLFLAGS += -g -Xlinker --wrap -Xlinker malloc -Xlinker --wrap -Xlinker strdup -Xlinker --wrap -Xlinker calloc  -Xlinker --wrap -Xlinker free -Xlinker --wrap -Xlinker vasprintf
endif
'
}
